<?php
namespace Inti\Wp\Authentication;

use Inti\Wp\WordPressMiddleware;
use Psr\Container\ContainerInterface;
use Psr\Http\Server\MiddlewareInterface;
use Zend\Expressive\Authentication\AuthenticationMiddlewareFactory as BaseAuthenticationMiddlewareFactory;
use Zend\Stratigility\MiddlewarePipe;

/**
 * Class WordPressAuthenticationFactory
 *
 * @package Inti\Wp\Authentication
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class AuthenticationMiddlewareFactory
{
    /**
     * @param ContainerInterface $container
     * @return MiddlewareInterface
     */
    public function __invoke(ContainerInterface $container): MiddlewareInterface
    {
        $middleware = new MiddlewarePipe();
        $factory = new BaseAuthenticationMiddlewareFactory();

        $middleware->pipe($container->get(WordPressMiddleware::class));
        $middleware->pipe($factory($container));

        return $middleware;
    }
}