<?php
namespace Inti\Wp\Plugin;

use Psr\Container\ContainerInterface;

/**
 * Class PluginLoaderFactory
 *
 * @package Inti\Wp\Plugin
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class PluginLoaderFactory
{
    /**
     * @param ContainerInterface $container
     * @return PluginLoader
     */
    public function __invoke(ContainerInterface $container): PluginLoader
    {
        $loader = new PluginLoader();
        $plugins = $container->get('config')['wp']['plugins'] ?? [];

        foreach ($plugins as $plugin) {
            $loader->addPlugin($container->get($plugin));
        }

        return $loader;
    }
}