<?php
namespace Inti\Wp;

use Psr\Container\ContainerInterface;
use Psr\Http\Server\MiddlewareInterface;
use Zend\Stratigility\Middleware\RequestHandlerMiddleware;
use Zend\Stratigility\MiddlewarePipe;

/**
 * Class WordPressMiddlewareFactory
 *
 * @package Inti\Wp
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class WordPressHandlerFactory
{
    /**
     * @param ContainerInterface $container
     * @return MiddlewareInterface
     */
    public function __invoke(ContainerInterface $container): MiddlewareInterface
    {
        $middleware = new MiddlewarePipe();

        $middleware->pipe($container->get(WordPressMiddleware::class));
        $middleware->pipe(new RequestHandlerMiddleware(new WordPressHandler()));

        return $middleware;
    }
}