<?php
namespace Inti\Wp;


use Inti\Config\Middleware\ConfigMiddleware;
use Psr\Container\ContainerInterface;
use Psr\Http\Server\MiddlewareInterface;
use Zend\Stratigility\MiddlewarePipe;

/**
 * Class WordPressMiddlewareFactory
 *
 * @package Inti\Wp
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class WordPressMiddlewareFactory
{
    /**
     * @param ContainerInterface $container
     * @return MiddlewareInterface
     */
    public function __invoke(ContainerInterface $container): MiddlewareInterface
    {
        $middleware = new MiddlewarePipe();

        $middleware->pipe($container->get(ConfigMiddleware::class));
        $middleware->pipe(new WordPressMiddleware());

        return $middleware;
    }
}
